Package: R.oo
Version: 1.27.1
Depends: R (>= 2.13.0), R.methodsS3 (>= 1.8.2)
Imports: methods, utils
Suggests: tools
Title: R Object-Oriented Programming with or without References
Authors@R: c(person("Henrik", "Bengtsson", role=c("aut", "cre", "cph"),
                                          email = "henrikb@braju.com"))
Author: Henrik Bengtsson [aut, cre, cph]
Maintainer: Henrik Bengtsson <henrikb@braju.com>
Description: Methods and classes for object-oriented programming in R with or without references.  Large effort has been made on making definition of methods as simple as possible with a minimum of maintenance for package developers.  The package has been developed since 2001 and is now considered very stable.  This is a cross-platform package implemented in pure R that defines standard S3 classes without any tricks.
License: LGPL (>= 2.1)
LazyLoad: TRUE
URL: https://henrikbengtsson.github.io/R.oo/,
        https://github.com/HenrikBengtsson/R.oo
BugReports: https://github.com/HenrikBengtsson/R.oo/issues
NeedsCompilation: no
Packaged: 2025-05-02 20:29:15 UTC; henrik
Repository: CRAN
Date/Publication: 2025-05-02 21:00:05 UTC
Built: R 4.4.0; ; 2026-05-11 18:20:44 UTC; unix

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# IMPORTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
importFrom("R.methodsS3", "setMethodS3")
importFrom("R.methodsS3", "setGenericS3")
importFrom("R.methodsS3", "isGenericS3")
importFrom("R.methodsS3", "pkgStartupMessage")
importFrom("R.methodsS3", "appendVarArgs")

importFrom("methods", "getClasses")
if (getRversion() < "4.5.0") {
  importFrom("methods", "getMethods")
}
importFrom("methods", "getClass")
importFrom("methods", "isClass")

importFrom("utils", "as.person")
importFrom("utils", "capture.output")
importFrom("utils", "citation")
importFrom("utils", "compareVersion")
importFrom("utils", "file_test")
importFrom("utils", "install.packages")
importFrom("utils", "installed.packages")
importFrom("utils", "object.size")
importFrom("utils", "old.packages")
importFrom("utils", "packageDescription")
importFrom("utils", "sessionInfo")
importFrom("utils", "str")
importFrom("utils", "update.packages")
importFrom("utils", ".DollarNames")

if (getRversion() >= "2.14.0") {
  importFrom("stats", "getCall")
}
if (getRversion() >= "3.3.0" && "getSource" %in% getNamespaceExports("utils")) {
  importFrom("utils", "getSource")
}

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# EXPORTS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Export all public methods, that is, those without a preceeding dot
# in their names.
exportPattern("^[^\\.]")


# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# DECLARATIONS
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

# BasicObject
S3method(".subset2Internal", "BasicObject")
S3method("$", "BasicObject")
S3method("$<-", "BasicObject")
S3method("[[", "BasicObject")
S3method("[[<-", "BasicObject")
S3method("as.character", "BasicObject")
S3method("attach", "BasicObject")
S3method("detach", "BasicObject")
S3method("equals", "BasicObject")
S3method("extend", "BasicObject")
S3method("getFields", "BasicObject")
S3method("getInstantiationTime", "BasicObject")
S3method("hasField", "BasicObject")
S3method("hashCode", "BasicObject")
S3method("isReferable", "BasicObject")
S3method("newInstance", "BasicObject")
S3method("objectSize", "BasicObject")
S3method("print", "BasicObject")
S3method(".DollarNames", "BasicObject")

# character
S3method("uses", "character")

# Class
S3method(".subset2Internal", "Class")
S3method("$", "Class")
S3method("$<-", "Class")
S3method("[[", "Class")
S3method("[[<-", "Class")
S3method("argsToString", "Class")
S3method("as.character", "Class")
S3method("forName", "Class")
S3method("getDetails", "Class")
S3method("getFields", "Class")
S3method("getKnownSubclasses", "Class")
S3method("getMethods", "Class")
S3method("getName", "Class")
S3method("getPackage", "Class")
S3method("getRdDeclaration", "Class")
S3method("getRdHierarchy", "Class")
S3method("getRdMethods", "Class")
S3method("getStaticInstance", "Class")
S3method("getSuperclasses", "Class")
S3method("isAbstract", "Class")
S3method("isBeingCreated", "Class")
S3method("isDeprecated", "Class")
S3method("isPrivate", "Class")
S3method("isProtected", "Class")
S3method("isPublic", "Class")
S3method("isStatic", "Class")
S3method("newInstance", "Class")
S3method("print", "Class")
S3method(".DollarNames", "Class")

# classRepresentation
S3method("getKnownSubclasses", "classRepresentation")
S3method("getRdDeclaration", "classRepresentation")
S3method("getRdHierarchy", "classRepresentation")
S3method("getRdMethods", "classRepresentation")
S3method("getSuperclasses", "classRepresentation")

# condition
S3method("abort", "condition")

# default
S3method("abort", "default")
S3method("attach", "default")
S3method("callSuperMethodS3", "default")
S3method("charToInt", "default")
S3method("detach", "default")
S3method("dimension", "default")
S3method("equals", "default")
S3method("extend", "default")
S3method("getConstructorS3", "default")
S3method("hashCode", "default")
S3method("intToChar", "default")
S3method("ll", "default")
S3method("load", "default")
S3method("objectSize", "default")
S3method("save", "default")
S3method("setConstructorS3", "default")
S3method("throw", "default")
S3method("trim", "default")
S3method("typeOfClass", "default")

# environment
S3method("getName", "environment")
S3method("objectSize", "environment")

# error
S3method("throw", "error")

# Exception
S3method("as.character", "Exception")
if (getRversion() >= "2.14.0") {
  S3method("getCall", "Exception")
}
S3method("getCalls", "Exception")
S3method("getLastException", "Exception")
S3method("getMessage", "Exception")
S3method("getStackTrace", "Exception")
S3method("getStackTraceString", "Exception")
S3method("getWhen", "Exception")
S3method("print", "Exception")
S3method("printStackTrace", "Exception")
S3method("throw", "Exception")

# Interface
S3method("as.character", "Interface")
S3method("extend", "Interface")
S3method("getFields", "Interface")
S3method("print", "Interface")
S3method("uses", "Interface")

# InternalErrorException
S3method("getMessage", "InternalErrorException")
S3method("getPackage", "InternalErrorException")

# Object
S3method(".subset2Internal", "Object")
S3method("$", "Object")
S3method("$<-", "Object")
S3method("[[", "Object")
S3method("[[<-", "Object")
S3method("as.character", "Object")
S3method("attach", "Object")
S3method("attachLocally", "Object")
S3method("clearCache", "Object")
S3method("clearLookupCache", "Object")
S3method("clone", "Object")
S3method("detach", "Object")
S3method("equals", "Object")
S3method("extend", "Object")
S3method("finalize", "Object")
S3method("getEnvironment", "Object")
S3method("getFieldModifier", "Object")
S3method("getFieldModifiers", "Object")
S3method("getFields", "Object")
S3method("getInstantiationTime", "Object")
S3method("getInternalAddress", "Object")
S3method("getStaticInstance", "Object")
S3method("hasField", "Object")
S3method("hashCode", "Object")
S3method("isReferable", "Object")
S3method("ll", "Object")
S3method("load", "Object")
S3method("names", "Object")
S3method("newInstance", "Object")
S3method("novirtual", "Object")
S3method("objectSize", "Object")
S3method("print", "Object")
S3method("save", "Object")
S3method("staticCode", "Object")
S3method(".DollarNames", "Object")

# Package
S3method("as.character", "Package")
S3method("getAuthor", "Package")
S3method("getBundle", "Package")
S3method("getBundlePackages", "Package")
S3method("getChangeLog", "Package")
S3method("getClasses", "Package")
S3method("getContents", "Package")
S3method("getContribUrl", "Package")
S3method("getDataPath", "Package")
S3method("getDate", "Package")
S3method("getDescription", "Package")
S3method("getDescriptionFile", "Package")
S3method("getDevelUrl", "Package")
S3method("getDocPath", "Package")
S3method("getEnvironment", "Package")
S3method("getExamplePath", "Package")
S3method("getHistory", "Package")
S3method("getHowToCite", "Package")
S3method("getLicense", "Package")
S3method("getMaintainer", "Package")
S3method("getName", "Package")
S3method("getNews", "Package")
S3method("getPath", "Package")
S3method("getPosition", "Package")
S3method("getTitle", "Package")
S3method("getUrl", "Package")
S3method("getVersion", "Package")
S3method("isLoaded", "Package")
S3method("isOlderThan", "Package")
S3method("ll", "Package")
S3method("load", "Package")
S3method("showChangeLog", "Package")
S3method("showContents", "Package")
S3method("showDescriptionFile", "Package")
S3method("showHistory", "Package")
S3method("showHowToCite", "Package")
S3method("showNews", "Package")
S3method("startupMessage", "Package")
S3method("unload", "Package")

# RccViolationException
S3method("as.character", "RccViolationException")
S3method("getRccUrl", "RccViolationException")

# Rdoc
S3method("argsToString", "Rdoc")
S3method("check", "Rdoc")
S3method("compile", "Rdoc")
S3method("createManPath", "Rdoc")
S3method("createName", "Rdoc")
S3method("declaration", "Rdoc")
S3method("escapeRdFilename", "Rdoc")
S3method("getClassS4Usage", "Rdoc")
S3method("getKeywords", "Rdoc")
S3method("getManPath", "Rdoc")
S3method("getNameFormat", "Rdoc")
S3method("getObject", "Rdoc")
S3method("getPackageNameOf", "Rdoc")
S3method("getRdTitle", "Rdoc")
S3method("getUsage", "Rdoc")
S3method("hierarchy", "Rdoc")
S3method("isKeyword", "Rdoc")
S3method("isVisible", "Rdoc")
S3method("methodsInheritedFrom", "Rdoc")
S3method("setManPath", "Rdoc")
S3method("setNameFormat", "Rdoc")

# RdocException
S3method("as.character", "RdocException")
S3method("getSource", "RdocException")

# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
## Should be renamed/removed from API
# - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# default
S3method("getClasses", "default")
if (getRversion() < "4.5.0") {
  S3method("getMethods", "default")
}  

message("TESTING: local()...")

library("R.oo")

setConstructorS3("Foo", function() {
  extend(Object(), "Foo")
})

setMethodS3("finalize", "Foo", function(this, ...) {
  cat("Finalized Foo\n")
})

x <- Foo()
print(x)

# Trigger finalizer via garbage collection
rm(list="x")
gc()



local({

setConstructorS3("Bar", function() {
  extend(Object(), "Bar")
})

setMethodS3("finalize", "Bar", function(this, ...) {
  cat("Finalized Bar\n")
})

x <- Bar()
print(x)

# Trigger finalizer via garbage collection
rm(list="x")
gc()

})

message("TESTING: local()...DONE")

library("R.methodsS3")
library("R.oo")

oopts <- options(warn=1L)

message("TESTING: finalize() on Object on and off ...")

finalized <- NULL
if ("covr" %in% loadedNamespaces()) {
  assertFinalization <- function(name) TRUE
} else {
  assertFinalization <- function(name) {
    cat(sprintf("Is '%s' in '%s'?\n", name, paste(finalized, collapse=", ")))
    stopifnot(is.element(name, finalized))
  }
}

name <- NULL
nextName <- function() {
  if (is.null(name)) return(letters[1L])
  letters[which(letters == name) + 1L]
}

setMethodS3("finalize", "Foo", function(this, ...) {
  cat(sprintf("Finalizing %s()...\n", class(this)[1L]))
  name <- unclass(this)
  cat(sprintf("  Value: %s\n", name))
  finalized <<- c(finalized, name)
  cat(sprintf("Finalizing %s()...done\n", class(this)[1L]))
})


setConstructorS3("Foo", function(..., ...finalize=NA) {
  extend(Object(...), "Foo", ...finalize=...finalize)
})

# Default
x <- Foo(name <- nextName())
rm(list="x"); gc()
assertFinalization(name)

# Default (explicit)
x <- Foo(name <- nextName(), finalize=TRUE, ...finalize=NA)
rm(list="x"); gc()
str(finalized)
assertFinalization(name)

# Disable
x <- Foo(name <- nextName(), finalize=FALSE, ...finalize=FALSE)
rm(list="x"); gc()
str(finalized)

# Disable (forced)
x <- Foo(name <- nextName(), finalize=TRUE, ...finalize=FALSE)
rm(list="x"); gc()
str(finalized)

# Enable (forced)
x <- Foo(name <- nextName(), finalize=FALSE, ...finalize=TRUE)
rm(list="x"); gc()
str(finalized)
assertFinalization(name)

print(finalized)

# Finalize upon exit
options("R.oo::Object/finalizeOnExit"=TRUE)
y <- Foo(name <- "OnExit")

message("TESTING: finalize() on Object on and off ... DONE")

options(oopts)

message("TESTING: abort()...")

library("R.oo")

foo <- function() {
  cat("foo()...\n")
  on.exit(cat("foo()...done\n"))
  tryCatch({
    stop("Woops!")
  }, error = function(ex) {
    cat("An error was caught: ", ex$message, "\n", sep="")
  })
  cat("Continuing...\n")
}

bar <- function() {
  cat("bar()...\n")
  on.exit(cat("bar()...done\n"))
  tryCatch({
    abort("Woops!")
  }, error = function(ex) {
    cat("An error was caught: ", ex$message, "\n", sep="")
  })
  cat("This message will never be displayed...\n")
}

# An error generated by stop() can be caught
foo()

## abort() will abort covr::package_coverage() and
## and any other evaluations beyond this point.
if (!"covr" %in% loadedNamespaces() && FALSE) {
# ...which is not possible when using abort()
bar()

# This expression is never reached
cat("This line will never be outputted.\n")
} #

message("TESTING: abort()...DONE")

library("R.oo")

message("TESTING: Interface...")

int <- Interface()
print(int)

setConstructorS3("MyInterface", function(...) {
  extend(Interface(), "MyInterface")
})
int <- MyInterface()
print(int)

setConstructorS3("MyClass", function(...) {
  extend(Object(), c("MyClass", uses(MyInterface(), Interface())))
})
obj <- MyClass()
print(obj)


## For some reason uses(<string>) doesn't play well with covr
if (!"covr" %in% loadedNamespaces()) {
  setConstructorS3("MyClass", function(...) {
    extend(Object(), c("MyClass", uses("MyInterface", "Interface")))
  })
  obj <- MyClass()
  print(obj)
}

message("TESTING: Interface...DONE")

oopts <- options(warn=1L)

message("TESTING: finalize() on Object without attach ...")

pkgs <- c("R.methodsS3", "R.oo")
isAttached <- function(pkgs) {
  structure(sprintf("package:%s", pkgs) %in% search(), names=pkgs)
}

# Record which packages were attached from the beginning
# (happens if not a fresh session)
wasAttached <- isAttached(pkgs)


assertPackages <- function(loaded=c("R.methodsS3", "R.oo")) {
  s <- utils::sessionInfo()
  s$R.version <- NULL
  s$platform <- ""
  s$locale <- ""
  cat("----------------------------------")
  print(s)
  cat("----------------------------------\n\n")
  loaded <- loaded[!wasAttached[loaded]]
  stopifnot(!any(isAttached(loaded)))
}

R.oo::setConstructorS3("MyClass", function(a=1:10) {
  R.oo::extend(R.oo::Object(), "MyClass", a=a)
})

# Create an object with a finalizer
x <- MyClass()

assertPackages()

# Remove 'x' so that it will be finalized below
rm(x)
gc()

assertPackages(loaded="R.oo")

message("TESTING: finalize() on Object without attach ... DONE")

options(oopts)

message("TESTING: Package...")

library("R.oo")

# By defining .onAttach() as follows in zzz.R for a package, an
# instance of class Package with the same name as the package will
# be made available on the search path. More over, the code below
# will also inform the user that the package has been loaded:
#
#  > library(R.oo)
#  R.oo v0.52 (2003/04/13) was successfully loaded.
#
.onAttach <- function(libname, pkgname) {
  pkg <- Package(pkgname)
  assign(pkgname, pkg, pos=getPosition(pkg))
  cat(getName(pkg), " v", getVersion(pkg), " (", getDate(pkg), ")",
    " was successfully loaded.\n", sep="")
}

# The Package class works for any packages, loaded or not.

# Some information about the base package
pkg <- Package("base")
print(pkg)
# [1] "Package: base v3.6.2 is loaded (pos=14).  Title: The R Base Package.
# The official webpage is NA and the maintainer is R Core Team <R-core@
# r-project.org>.  The package is installed in /usr/lib/R/library/base/.
# License: Part of R 3.6.2.  Description: Base R functions.  Type 
# showNews(base) for package history, and ?base for help."
print(list.files(Package("base")$dataPath))

# Some information about the R.oo package
print(R.oo::R.oo)
# [1] "Package: R.oo v1.23.0-9000 .  Title: R Object-Oriented Programming 
# with or without References.  The official webpage is https://github.com/
# HenrikBengtsson/R.oo and the maintainer is Henrik Bengtsson.  The package
# is installed in /home/alice/R/x86_64-pc-linux-gnu-library/3.6/R.oo/.
# License: LGPL (>= 2.1).  Description: Methods and classes for object-
# oriented programming in R with or without references.  Large effort has
# been made on making definition of methods as simple as possible with a 
# minimum of maintenance for package developers.  The package has been 
# developed since 2001 and is now considered very stable.  This is a 
# cross-platform package implemented in pure R that defines standard S3
# classes without any tricks.  Type showNews(R.oo) for package history,
# and ?R.oo for help."

pkg <- Package("R.oo")
classes <- getClasses(pkg)
print(classes)
stopifnot(all(c("Object", "Class", "Interface", "Exception", "Package") %in% classes))

pkg <- Package("R.oo")
res <- showDescriptionFile(pkg, pager=function(...) TRUE)
stopifnot(isTRUE(res))
res <- showNews(pkg, pager=function(...) TRUE)
stopifnot(isTRUE(res))
res <- showChangeLog(pkg, pager=function(...) TRUE)
stopifnot(isTRUE(res))
res <- showHistory(pkg, pager=function(...) TRUE)
stopifnot(isTRUE(res))


res <- try(Package("Non-Existing-Package"), silent=TRUE)
stopifnot(inherits(res, "try-error"))

message("TESTING: Package...DONE")

message("TESTING: finalize() reentrant...")

## FIXME: 'covr' does not play well with tests
## detaching/unloading packages
if ("covr" %in% loadedNamespaces()) {
  detach <- function(...) NULL
}


library("R.methodsS3")
library("R.oo")

lotsOfParsing <- function(code="y <- 1:3") {
  parse(text=rep(code, times=10000))
}

setConstructorS3("MyClass", function(a=1:10) {
  extend(Object(), "MyClass", a=a)
})

setMethodS3("finalize", "MyClass", function(this, ...) {
  cat("finalize...\n")
  utils::str(sys.calls())
  cat("finalize...done\n")
})

# Parse and eval expression (works)
expr <- lotsOfParsing()
eval(expr)
print(y)
## [1] 1 2 3
stopifnot(identical(y, 1:3))

# Create an object with a finalizer
x <- MyClass()

# Detach R.oo so that the finalizer will try to reload it
detach("package:R.oo")

# Remove 'x' so that it will be finalized below
rm(x)


# This may trigger garbage collection via parse()
# If so, it is important that parse() is not called
# (indirectly via library()) by the finalizer.
# Because otherwise R may crash.
expr2 <- lotsOfParsing(code="y <- 1:4")
## finalize...
## Dotted pair list of 9
##  $ : ...
##  ...
##  $ : language function (env)  { ...
##  $ : language finalize(this)
##  $ : language finalize.MyClass(this)
## Parse called: TRUE
## finalize...done
eval(expr2)
print(y)
## [1] 1 2 3 4
stopifnot(identical(y, 1:4))

print(warnings())

message("TESTING: finalize() reentrant...DONE")

message("TESTING: isBeingCreated()...")

library("R.oo")

setConstructorS3("Car", function(brand=NULL, nbrOfWheels=0) {
  if(!isBeingCreated(Car)) {
    if (is.null(brand))
      throw("A car must have a brand")

    if (nbrOfWheels <= 0)
      throw("A car must have one or more wheels: ", nbrOfWheels)
  }

  extend(Object(), "Car",
    .brand = brand,
    .nbrOfWheels = nbrOfWheels
  )
})

setMethodS3("as.character", "Car", function(this, ...) {
  cat(class(this)[1], ":", this$.brand, " with ",
                     this$.nbrOfWheels, " wheels.", sep="")
})

print(Car("Volvo", 4))
print(Car("BMW", 4))
print(Car("Tyrrell P34", 6))
print(Car("T-Rex", 3))

message("TESTING: isBeingCreated()...DONE")

message("TESTING: equals()...")

library("R.oo")

print(equals(1,1))
print(equals(1,2))
a <- 1:100
b <- 1:100
print(equals(a,b))

obj <- Object()
print(equals(obj, 1))
print(equals(obj, obj))


message("TESTING: equals()...DONE")

library(R.oo)

message("hashCode() ...")

message("- NULL")

y <- hashCode(NULL)
print(y)
stopifnot(is.null(y))


message("- empty vectors")

y <- hashCode(character(0L))
print(y)
stopifnot(is.null(y))

y <- hashCode(integer(0L))
print(y)
stopifnot(is.null(y))

y <- hashCode(double(0L))
print(y)
stopifnot(is.null(y))

y <- hashCode(list())
print(y)
stopifnot(is.null(y))


message("- strings")

x <- ""
y <- hashCode(x)
print(y)
stopifnot(
  is.integer(y),
  length(y) == length(x),
  !anyNA(y),
  y == 0L
)

x <- base::letters
y <- hashCode(x)
print(y)
stopifnot(
  is.integer(y),
  length(y) == length(x),
  !anyNA(y),
  all(y == charToInt(base::letters))
)

x <- "abcdefghij"
y <- hashCode(x)
print(y)
stopifnot(
  is.integer(y),
  length(y) == length(x),
  !anyNA(y),
  y == -634317659L
)

x <- "abcdefghijklmno"
y <- hashCode(x)
print(y)
stopifnot(
  is.integer(y),
  length(y) == length(x),
  !anyNA(y),
  y == 486644840L
)


## Assert no integer overflow => NA
for (n in seq_along(base::letters)) {
  x <- paste(base::letters[seq_len(n)], collapse = "")
  y <- hashCode(x)
  cat(sprintf("%s => %d\n", x, y))
  stopifnot(
    is.integer(y),
    length(y) == length(x),
    !anyNA(y)
  )
}

message("- integers")

x <- 1:10
y <- hashCode(x)
print(y)
stopifnot(
  is.integer(y),
  length(y) == length(x),
  !anyNA(y),
  all(y == x)
)

message("- doubles")

x <- as.numeric(1:10)
y <- hashCode(x)
print(y)
stopifnot(
  is.integer(y),
  length(y) == length(x),
  !anyNA(y),
  all(y == as.integer(x))
)


message("- complex")

x <- 1:10 + 0.1
y <- hashCode(x)
print(y)
stopifnot(
  is.integer(y),
  length(y) == length(x),
  !anyNA(y),
  all(y == 1:10)
)

message("- miscellaneous types")

x <- list(0L)
y <- hashCode(x)
print(y)
stopifnot(
  is.integer(y),
  length(y) == length(x),
  !anyNA(y),
  y == 0L
)

x <- as.list(1:10)
y <- hashCode(x)
print(y)
stopifnot(
  is.integer(y),
  length(y) == length(x),
  !anyNA(y),
  all(y == 1:10)
)


message("hashCode() ... DONE")

message("TESTING: trim()...")

library("R.oo")

x <- character(0L)
y <- trim(x)
print(y)
stopifnot(identical(y, x))

x <- "Hello world!"
y <- trim(x)
print(y)
stopifnot(identical(y, x))

x <- " \tHello world!\n "
y <- trim(x)
print(y)
stopifnot(identical(y, "Hello world!"))

x <- c(" \tHello",  "world!")
y <- trim(x)
print(y)
stopifnot(identical(y, c("Hello", "world!")))


message("TESTING: trim()...DONE")

message("TESTING: typeOfClass()...")

library("R.oo")

type <- typeOfClass(NULL)
print(type)
stopifnot(is.na(type))

type <- typeOfClass(Object)
print(type)
stopifnot(type == "S3-Object")

type <- typeOfClass("Object")
print(type)
stopifnot(type == "S3-Object")

library("methods")
type <- typeOfClass("data.frame")
print(type)
stopifnot(type == "S4")

clazz <- getClass("data.frame")
type <- typeOfClass(clazz)
print(type)
stopifnot(type == "S4")

type <- typeOfClass("Non-Existing-Class")
print(type)
stopifnot(is.na(type))

message("TESTING: typeOfClass()...DONE")

message("TESTING: Object...")

library("R.oo")

obj <- Object()
print(obj)

obj <- Object(42L)
print(obj)
stopifnot(obj == 42L)

obj$a <- 1:99
print(obj)

fields <- getFields(obj)
print(fields)

hasA <- hasField(obj, "a")
print(hasA)
stopifnot(hasA)

value <- obj$a
str(value)
stopifnot(identical(value, 1:99))

obj$a <- 1:100
print(obj)

value <- obj[["a"]]
str(value)
stopifnot(identical(value, 1:100))

obj[["a"]] <- 1:101
print(obj)

value <- obj[["a"]]
str(value)
stopifnot(identical(value, 1:101))

size <- objectSize(obj)
print(size)

ref <- isReferable(obj)
print(ref)
stopifnot(isTRUE(ref))

time <- getInstantiationTime(obj)
print(time)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Attach and detach
# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
res <- attach(obj)
print(res)
stopifnot(exists("a", mode="integer"))
str(a)

## Object already attached
res <- tryCatch(attach(obj), warning=function(w) w)
stopifnot(inherits(res, "warning"))

res <- detach(obj)
print(res)

## Object already detached
res <- tryCatch(detach(obj), warning=function(w) w)
stopifnot(inherits(res, "warning"))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Save and load
# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
obj <- Object()
obj$a <- 1
obj$b <- 2
pathnameT <- tempfile()
save(obj, file=pathnameT)

obj2 <- Object$load(pathnameT)
stopifnot(all.equal(getFields(obj2), getFields(obj)))
for (key in getFields(obj)) {
  stopifnot(identical(obj2[[key]], obj[[key]]))
}

file.remove(pathnameT)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Class
# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
obj2 <- newInstance(obj, 43L)
print(obj2)
stopifnot(obj2 == 43L)


hash <- hashCode(obj)
print(hash)
stopifnot(length(hash) == 1L)

neq <- equals(obj, 1)
print(neq)
stopifnot(!neq)

eq <- equals(obj, obj)
print(eq)
stopifnot(eq)

obj3 <- clone(obj)
print(obj3)
stopifnot(!identical(obj3, obj))
stopifnot(all.equal(obj3, obj))


message("TESTING: Object...DONE")

message("TESTING: objectSize()...")

library("R.oo")

## Simple object
x <- 1:100
y0 <- object.size(x)
y <- objectSize(x)
print(y)
stopifnot(y == y0)

## A list
x <- as.list(1:100)
y0 <- object.size(x)
y <- objectSize(x)
print(y)
stopifnot(y == y0)

## An environment
env <- new.env()
env$a <- 1:100
env$b <- as.list(1:100)
env$c <- new.env()
y0 <- object.size(env)
print(y0)
y <- objectSize(env)
print(y)

## An environment with circular dependencies
env <- new.env()
env$a <- 1:100
env$env <- env
y0 <- object.size(env)
print(y0)
y <- objectSize(env)
print(y)

message("TESTING: objectSize()...DONE")

message("TESTING: Exception...")

library("R.oo")
oopts <- options(warn=1)

######################################################################
# 1. To catch a regular "error" exception thrown by e.g. stop().
######################################################################
x <- NA
y <- NA
tryCatch({
  x <- log(123)
  y <- log("a")
}, error = function(ex) {
  print(ex)
})
print(x)
print(y)



######################################################################
# 2. Always run a "final" expression regardless or error or not.
######################################################################
filename <- tempfile("R.methodsS3.example")
con <- file(filename)
tryCatch({
  open(con, "r")
}, error = function(ex) {
  cat("Could not open ", filename, " for reading.\n", sep="")
}, finally = {
  close(con)
  cat("The id of the connection is ",
       ifelse(is.null(con), "NULL", con), ".\n", sep="")
})


######################################################################
# 3. Creating your own Exception class
######################################################################
setConstructorS3("NegativeLogValueException", function(
  msg="Trying to calculate the logarithm of a negative value", value=NULL) {
  extend(Exception(msg=msg), "NegativeLogValueException",
    .value = value
  )
})

setMethodS3("as.character", "NegativeLogValueException", function(this, ...) {
  paste(as.character.Exception(this), ": ", getValue(this), sep="")
})

setMethodS3("getValue", "NegativeLogValueException", function(this, ...) {
  this$.value
})


mylog <- function(x, base=exp(1)) {
  if (x < 0)
    throw(NegativeLogValueException(value=x))
  else
    log(x, base=base)
}


# Note that the order of the catch list is important:
l <- NA
x <- 123
tryCatch({
  l <- mylog(x)
}, NegativeLogValueException = function(ex) {
  cat(as.character(ex), "\n")
}, "try-error" = function(ex) {
  cat("try-error: Could not calculate the logarithm of ", x, ".\n", sep="")
}, error = function(ex) {
  cat("error: Could not calculate the logarithm of ", x, ".\n", sep="")
})
cat("The logarithm of ", x, " is ", l, ".\n\n", sep="")

options(oopts)

message("TESTING: Exception...DONE")

message("TESTING: BasicObject...")

library("R.oo")

obj <- BasicObject()
print(obj)

obj <- BasicObject(42L)
print(obj)
stopifnot(obj == 42L)

obj$a <- 1:99
print(obj)

fields <- getFields(obj)
print(fields)

hasA <- hasField(obj, "a")
print(hasA)
stopifnot(hasA)

value <- obj$a
str(value)
stopifnot(identical(value, 1:99))

obj$a <- 1:100
print(obj)

value <- obj[["a"]]
str(value)
stopifnot(identical(value, 1:100))

obj[["a"]] <- 1:101
print(obj)

value <- obj[["a"]]
str(value)
stopifnot(identical(value, 1:101))

size <- objectSize(obj)
print(size)

ref <- isReferable(obj)
print(ref)
stopifnot(isTRUE(ref))

time <- getInstantiationTime(obj)
print(time)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Attach and detach
# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
obj <- BasicObject(42L)
obj$a <- 1:99

res <- attach(obj)
print(res)
stopifnot(exists("a", mode="integer"))
str(a)

## Object already attached
res <- tryCatch(attach(obj), warning=function(w) w)
stopifnot(inherits(res, "warning"))

res <- detach(obj)
print(res)

## Object already detached
res <- tryCatch(detach(obj), warning=function(w) w)
stopifnot(inherits(res, "warning"))


obj <- BasicObject(list(a=1L, b=2, c=3))

res <- attach(obj)
print(res)
stopifnot(exists("a", mode="integer"))
str(a)

res <- detach(obj)
print(res)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Class
# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
obj2 <- newInstance(obj, 43L)
print(obj2)
stopifnot(obj2 == 43L)


# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# Inheritance
# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
setConstructorS3("MyObject", function(...) {
  extend(BasicObject(), "MyObject", ...)
})
obj <- MyObject(a=1, b=2)
print(obj)
str(obj)
stopifnot(all(c("a", "b") %in% names(attributes(obj))))


setMethodS3("foo", "MyObject", function(static, x=1L, ...) {
  list(x=x, ...)
}, static=TRUE)

res <- MyObject$foo(y=2L)
stopifnot(identical(res$x, 1L))
stopifnot(identical(res$y, 2L))

obj$a <- 3
print(obj)
value <- obj[["a"]]
str(value)
stopifnot(identical(value, 3))

obj[["a"]] <- 4
print(obj)
value <- obj$a
str(value)
stopifnot(identical(value, 4))


# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
# FIXME: hashCode() return integer(0) whenever
# getInstantiationTime() returns NULL, which is
# now the default behavior of BasicObject
# - - - - - - - - - - - - - - - - - - - - - - - - - - - -
hash <- hashCode(obj)
print(hash)
## FIXME: Currently returns integer(0)
## stopifnot(length(hash) == 1L)

neq <- equals(obj, 1)
print(neq)
## FIXME: Currently returns NA
## stopifnot(!neq)

eq <- equals(obj, obj)
print(eq)
## FIXME: Currently returns NA
## stopifnot(eq)


message("TESTING: BasicObject...DONE")

message("TESTING: attachLocally()...")

library("R.oo")

foo <- function(object, arg1="some value", ...) {
  cat("Local objects in foo():\n")
  print(ls())

  attachLocally(object)

  cat("\nLocal objects in foo():\n")
  print(ls())

  for (name in ls()) {
    cat("\nObject '", name, "':\n", sep="")
    print(get(name, inherits=FALSE))
  }
}

a <- "A string"
obj <- Object()
obj$a <- "Another string"
obj$b <- NA
foo(obj)
print(a)

message("TESTING: attachLocally()...DONE")

###########################################################################/**
# @RdocClass Exception
#
# \title{The Exception class to be thrown and caught}
#
# \description{
#  @classhierarchy
#
#  Creates an Exception that can be thrown and caught. The \code{Exception} 
#  class is the root class of all other \code{Exception} classes.
# }
#
# @synopsis
#
# \arguments{
#   \item{...}{One or several strings, which will be concatenated and contain
#     informative message about the exception.}
#   \item{sep}{The string to used for concatenating several strings.}
#   \item{collapse}{The string to used collapse vectors together.}
# }
#
# \section{Fields and Methods}{
#  @allmethods
# }
#
# @examples "Exception.Rex"
#
# @author
#
# \seealso{
#   See also @see "base::tryCatch" (and @see "base::try").
# }
#
# \keyword{programming}
# \keyword{methods}
# \keyword{error}
#*/###########################################################################
setConstructorS3("Exception", function(..., sep="", collapse=", ") {
  calls <- sys.calls();
  last.dump <- sys.frames();
  names(last.dump) <- limitedLabels(calls);
#  last.dump <- last.dump[-length(last.dump)];
  attr(last.dump, "error.message") <- geterrmessage();
  class(last.dump) <- "dump.frames";
  stackTrace <- NULL;
  if (length(last.dump) > 0) {
    calls <- names(last.dump);
    matchStr <- "Exception(";
    offset <- which(substr(calls, 1, nchar(matchStr)) == matchStr);
    if (length(offset) == 0 || offset == 1)
      stackTrace <- list("<prompt>"=NA)
    else
      stackTrace <- last.dump[1:(offset-1)];
  }

  # The new class is Exception, but for convenience it should also
  # derive from 'try-error', which is used by try() etc.
  extend(Object(), c("Exception", "simpleError", "error", "condition", "try-error"), 
    .msg        = paste(..., sep=sep, collapse=collapse),
    .when       = Sys.time(),
    .stackTrace = stackTrace
  )
})




###########################################################################/**
# @RdocMethod as.character
#
# \title{Gets a character string representing of the Exception}
#
# @synopsis
#
# \description{
#  @get "title". 
#  By default the format is: "[{POSIX date string}] {class name}: {msg}".
# }
#
# \value{
#  Returns a @character string.
# }
#
# \examples{\dontrun{For a complete example see help(Exception).}}
#
# @author
#
# \seealso{
#   @seeclass
# }
#
# \keyword{programming}
# \keyword{methods}
# \keyword{error}
#*/###########################################################################
setMethodS3("as.character", "Exception", function(this) {
  paste("[", getWhen(this), "] ", class(this)[1], ": ", getMessage(this), sep="");
})



###########################################################################/**
# @RdocMethod print
#
# \title{Prints the Exception}
#
# @synopsis
#
# \description{
#  @get "title". By default the \code{as.character()} representation plus
#  the stack trace is printed.
# }
#
# \value{Returns nothing.}
#
# \examples{\dontrun{For a complete example see help(Exception).}}
#
# @author
#
# \seealso{
#   @seemethod "as.character".
#   @seemethod "getStackTrace".
#   @seemethod "printStackTrace".
#   @seeclass
# }
#
# \keyword{programming}
# \keyword{methods}
# \keyword{error}
#*/###########################################################################
setMethodS3("print", "Exception", function(this) {
  cat(getStackTraceString(this));
})




###########################################################################/**
# @RdocMethod getWhen
#
# \title{Gets the time when the Exception was created}
#
# @synopsis
#
# \description{
#  Gets the time, as a POSIX object, when the Exception was created.
# }
#
# \value{
#  Returns a POSIX time object.
# }
#
# \examples{\dontrun{For a complete example see help(Exception).}}
#
# @author
#
# \seealso{
#   @seeclass
# }
#
# \keyword{programming}
# \keyword{methods}
# \keyword{error}
#*/###########################################################################
setMethodS3("getWhen", "Exception", function(this) {
  this$.when;
})





###########################################################################/**
# @RdocMethod getMessage
#
# @title "Gets the message of the Exception"
#
# @synopsis
#
# \description{
#  @get "title".
# }
#
# \value{
#  Returns a @character string.
# }
#
# \examples{\dontrun{For a complete example see help(Exception).}}
#
# @author
#
# \seealso{
#   @seeclass
# }
#
# \keyword{programming}
# \keyword{methods}
# \keyword{error}
#*/###########################################################################
setMethodS3("getMessage", "Exception", function(this) {
  this$.msg;
})




###########################################################################/**
# @RdocMethod throw
#
# \title{Throws an Exception that can be caught}
#
# @synopsis
#
# \description{
#  Throws an Exception that can be caught by \code{tryCatch()}.
# }
#
# \value{
#  Returns nothing.
# }
#
# \examples{\dontrun{For a complete example see help(Exception).}}
#
# @author
#
# \seealso{
#   @seeclass
#   See also @see "base::tryCatch".
# }
#
# \keyword{programming}
# \keyword{methods}
# \keyword{error}
#*/###########################################################################
setMethodS3("throw", "Exception", function(this) {
  Exception$.lastException <- this;
  message <- getStackTraceString(this);
#  message <- as.character(this);
  if (R.Version()$major <= 1 && R.Version()$minor < 8.0) {
    .Internal(stop(as.logical(FALSE), message));
  } else {
    signalCondition(this);
    .Internal(.dfltStop(paste("\n", getStackTraceString(this), sep=""), getCall(this)));
  } # if (R.Version()$major <= 1 && R.Version()$minor < 8.0) 
})




###########################################################################/**
# @RdocMethod getLastException
#
# \title{Static method to get the last Exception thrown}
#
# @usage
#
# \description{
#  Static method to get the last Exception instanciated.
# }
#
# \value{
#   Returns an @see "Exception" object.
# }
#
# \examples{\dontrun{For a complete example see help(Exception).}}
#
# \seealso{
#   @seeclass
#   See also @see "base::tryCatch".
# }
#
# @author
#
# \keyword{programming}
# \keyword{methods}
# \keyword{error}
#*/###########################################################################
setMethodS3("getLastException", "Exception", function(this) {
  Exception$.lastException;
}, static=TRUE);




###########################################################################/**
# @RdocMethod getStackTrace
# @aliasmethod getCall
#
# \title{Gets the stack trace saved when the exception was created}
#
# @synopsis
#
# \description{
#  @get "title".
# }
#
# \value{
#   Returns a @list containing the stack trace.
# }
#
# \examples{\dontrun{For a complete example see help(Exception).}}
#
# \seealso{
#   @seemethod "printStackTrace".
#   @see "base::dump.frames".
#   @see "base::tryCatch".
#   @seeclass
# }
#
# @author
#
# \keyword{programming}
# \keyword{methods}
# \keyword{error}
#*/###########################################################################
setMethodS3("getStackTrace", "Exception", function(this) {
  this$.stackTrace;
}) 
setMethodS3("getCall", "Exception", function(this) {
  getStackTrace(this);
}) 




###########################################################################/**
# @RdocMethod getStackTraceString
#
# \title{Gets the stack trace as a string}
#
# @synopsis
#
# \description{
#  @get "title".
# }
#
# \value{
#   Returns a @character string.
# }
#
# \seealso{
#   @seemethod "getStackTrace".
#   @seeclass
# }
#
# @author
#
# \keyword{programming}
# \keyword{methods}
# \keyword{error}
#*/###########################################################################
setMethodS3("getStackTraceString", "Exception", function(this) {
  calls <- names(this$.stackTrace);
  len <- length(calls);
  width <- floor(log(len, base=10))+1;
  s <- paste(this, "\n", sep="");
  for (k in len:1)
    s <- paste(sep="", s, "  at ", calls[k], "\n");
  s;
}, private=TRUE) 




###########################################################################/**
# @RdocMethod printStackTrace
#
# \title{Prints the stack trace saved when the exception was created}
#
# @synopsis
#
# \description{
#  @get "title".
# }
#
# \value{
#   Returns nothing.
# }
#
# \examples{\dontrun{For a complete example see help(Exception).}}
#
# \seealso{
#   @seemethod "getStackTrace".
#   @see "base::tryCatch".
#   @seeclass
# }
#
# @author
#
# \keyword{programming}
# \keyword{methods}
# \keyword{error}
#*/###########################################################################
setMethodS3("printStackTrace", "Exception", function(this) {
  cat(getStackTraceString(this));
}) 






############################################################################
# HISTORY:
# 2005-02-10
# o Moved showAndWait() from Exception to simpleError.
# 2004-10-18
# o Added more Rdoc comments.
# 2004-03-02
# o The Exception class now inherits from the simpleError, error and
#   condition classes.
# o The throw() method of Exception does now make use of the new (R v1.8.0)
#   signalCondition() method.
# 2003-12-16
# o Now throw() includes the complete stacktrace when generating an internal
#   error signal.
# 2003-04-13
# o Wrote Rdoc comments that were missing and updated some others.
# 2003-03-23
# o Added showAndAsk(), which will, if tcltk is installed, display a dialog
#   box with the error message. If tcltk is not installed, The message will
#   be printed on the command line and a prompt requesting the user to press
#   enter will be shown. showAndAsk() will give an error if run in a non-
#   interactive mode.
# 2003-01-19
# o Added stacktrace information to *each* Exception object. This is created
#   when the object is created.
# 2003-01-18
# o Replaced all occurences of getClass() with data.class(). Will change
#   the use of getClass() in the future to return a Class object. 
# 2002-10-17
# o Made getLastException() a static method of Exception.
# o Created from previous ideas in R.oo.
############################################################################

message("TESTING: throw()...")

library("R.oo")

## Generate an error
ex <- tryCatch({
  stop("An error")
}, error = function(ex) {
  ex
})
print(ex)

## Re-throw the error
ex2 <- tryCatch({
  throw(ex)
}, error = function(ex) {
  ex
})
print(ex2)

stopifnot(identical(ex2, ex))


## Generate an Exception
ex <- tryCatch({
  throw("An error")
}, error = function(ex) {
  ex
})
print(ex)

## Re-throw the Exception
ex2 <- tryCatch({
  throw(ex)
}, error = function(ex) {
  ex
})
print(ex2)

stopifnot(identical(ex2, ex))


message("TESTING: throw()...DONE")

message("TESTING: extend()...")

library("R.oo")

setConstructorS3("MyDouble", function(value=0, ...) {
  extend(as.double(value), "MyDouble", ...)
})

setMethodS3("as.character", "MyDouble", function(object, ...) {
  fmtstr <- attr(object, "fmtstr")
  if (is.null(fmtstr))
    fmtstr <- "%.6f"
  sprintf(fmtstr, object)
})

setMethodS3("print", "MyDouble", function(object, ...) {
  print(as.character(object), ...)
})

x <- MyDouble(3.1415926)
print(x)

x <- MyDouble(3.1415926, fmtstr="%3.2f")
print(x)
attr(x, "fmtstr") <- "%e"
print(x)






setConstructorS3("MyList", function(value=0, ...) {
  extend(list(value=value, ...), "MyList")
})

setMethodS3("as.character", "MyList", function(object, ...) {
  fmtstr <- object$fmtstr
  if (is.null(fmtstr))
    fmtstr <- "%.6f"
  sprintf(fmtstr, object$value)
})

setMethodS3("print", "MyList", function(object, ...) {
  print(as.character(object), ...)
})

x <- MyList(3.1415926)
print(x)
x <- MyList(3.1415926, fmtstr="%3.2f")
print(x)
x$fmtstr <- "%e"
print(x)

message("TESTING: extend()...DONE")

message("TESTING: ll()...")

library("R.oo")

## Create some objects in the current environment
a <- 1:100
env <- new.env()
env$b <- letters[1:10]

## List the content of evironments
x <- ll(envir=env)
print(x)

## Empty environment
x <- ll(envir=new.env())
print(x)

## search() path environment
x <- ll(envir=1L)
str(x)

## search() path environment
x <- ll(envir="R.oo")
str(x)

## Filter by name pattern
x <- ll(envir="R.oo", pattern="^throw.*")
print(x)

x <- ll(envir="R.oo", pattern="^NonExistingName$")
print(x)

## List all functions and sort them by size
x <- ll(envir="R.oo", mode="function", sortBy="objectSize")
str(x)

## List all functions of a package and sort them by size
x <- ll(R.oo, mode="function", sortBy="objectSize")
str(x)

## List all functions of an Object
obj <- Object()
obj$a <- 1:100
obj$b <- new.env()
x <- ll(obj)
print(x)

message("TESTING: ll()...DONE")

message("TESTING: Class...")

library("R.oo")

clazz <- Object
print(clazz)
print(as.character(clazz))


message(" - instantiation ...")
obj <- Object()
print(obj)
obj <- newInstance(clazz)
print(obj)
stopifnot(inherits(obj, "Object"))
obj <- clazz[["newInstance"]]()
print(obj)
stopifnot(inherits(obj, "Object"))
message(" - instantiation ... DONE")


message(" - reflection ...")
clazz <- Class$forName("Object")
print(clazz)
print(getKnownSubclasses(clazz))
static <- getStaticInstance(clazz)
print(static)
pkg <- getPackage(clazz)
print(pkg)
stopifnot(pkg == "R.oo")

## Odds and ends
print(isBeingCreated(clazz))

## FIXME: Case should never occur but code allows for it
print(isBeingCreated.Class(obj))
message(" - reflection ... DONE")


message(" - modifiers ...")
print(isAbstract(clazz))
print(isPrivate(clazz))
print(isProtected(clazz))
print(isPublic(clazz))
print(isDeprecated(clazz))
print(isStatic(clazz))  ## TRUE because of Object$load()
message(" - modifiers ... DONE")


message(" - inheritance ...")
setConstructorS3("MyClass", function(...) {
  extend(Object(), "MyClass", ...)
})

obj <- MyClass(a=1, b=2, c=3)
print(obj)
stopifnot(all(c("a", "b", "c") %in% names(obj)))

obj <- newInstance(MyClass, a=1, b=2, c=3)
print(obj)
stopifnot(all(c("a", "b", "c") %in% names(obj)))

message(" - inheritance ... DONE")



message("TESTING: Class...DONE")

message("TESTING: ASCII...")

library("R.oo")

## Display ASCII table
print(R.oo::ASCII)

idxs <- 1:255
str(idxs)

chars <- intToChar(idxs)
print(chars)
stopifnot(length(chars) == length(idxs))

idxs2 <- charToInt(chars)
str(idxs2)
stopifnot(length(idxs2) == length(chars))

stopifnot(identical(idxs2, idxs))


message("TESTING: ASCII...DONE")

library("R.oo")

oopts <- options(warn=1L)

message("TESTING: finalize() on Object ...")

setConstructorS3("MyClass", function() {
  extend(Object(), "MyClass")
})

setMethodS3("finalize", "MyClass", function(this, ...) {
  cat(as.character(this), "is about to be removed from the memory!\n")
})

o <- MyClass()
o <- MyClass()
o <- MyClass()
o <- MyClass()
gc()

## MyClass: 0x01BE602C is about to be removed from the memory!
## MyClass: 0x01BFF634 is about to be removed from the memory!
## MyClass: 0x01C13584 is about to be removed from the memory!
##          used (Mb) gc trigger (Mb)
## Ncells 229903  6.2     467875 12.5
## Vcells  53725  0.5     786432  6.0

rm(o)
## MyClass: 0x01C578B0 is about to be removed from the memory!
##          used (Mb) gc trigger (Mb)
## Ncells 229903  6.1     467875 12.3
## Vcells  53725  0.5     786432  6.0

message("TESTING: finalize() on Object ... DONE")

options(oopts)

message("TESTING: InternalErrorException...")

library("R.oo")

ex <- InternalErrorException("Hmm... I didn't expect this!")
print(ex)

ex2 <- InternalErrorException("Hmm... I didn't expect this!", package=R.oo)
print(ex2)

ex3 <- InternalErrorException("Hmm... I didn't expect this!", package="R.oo")
print(ex3)


myLog <- function(x, ...) {
  if (!is.numeric(x)) {
    throw(InternalErrorException("Argument 'x' to myLog() is not numeric: ",
                                                 mode(x), package=R.oo))
  }
  log(x, ...)
}


myLog(2)

ex <- NULL
tryCatch({
  myLog("a")
}, error= function(ex) {
  ex <- Exception$getLastException()
})

message("TESTING: InternalErrorException...DONE")
